# NOTE: Derived from blib/lib/Tie/Cacher.pm.
# Changes made here will be lost when autosplit is run again.
# See AutoSplit.pm.
package Tie::Cacher;

#line 158 "blib/lib/Tie/Cacher.pm (autosplit into blib/lib/auto/Tie/Cacher/fetch.al)"
sub fetch {
    my $cacher = $_[0];
    my $node = $cacher->[TC_NODES]{$_[1]};
    if ($node) {
        # Aha, existence is assured
        $cacher->[TC_HIT]++;

        # Detach node
        $node->[TC_NEXT][TC_PREVIOUS] = $node->[TC_PREVIOUS];
        $node->[TC_PREVIOUS][TC_NEXT] = $node->[TC_NEXT];

        # Reattach node in front
        my $head = $node->[TC_PREVIOUS] = $cacher->[TC_HEAD];
        my $next = $node->[TC_NEXT]	    = $head->[TC_NEXT];
        $head->[TC_NEXT] = $next->[TC_PREVIOUS] = $node;

        return $node->[TC_DATA] unless $cacher->[TC_VALIDATE];
        push(@_, $node);
        return $node->[TC_DATA] if &{$cacher->[TC_VALIDATE]};
        unless ($cacher->[TC_LOAD]) {
            $cacher->delete($_[1]);
            return;
        }
    } else {
        # Nope, new entry
        $cacher->[TC_MISSED]++;
        return unless $cacher->[TC_LOAD];
        if ($cacher->[TC_COUNT] >= $cacher->[TC_MAX_COUNT]) {
            # Drop an old one
            my $head = $cacher->[TC_HEAD];
            $node = $head->[TC_PREVIOUS];
            ($head->[TC_PREVIOUS] = $node->[TC_PREVIOUS])->[TC_NEXT] = $head;
            delete $cacher->[TC_NODES]{$node->[TC_KEY]};
        } else {
            $cacher->[TC_COUNT]++;
        }
        $cacher->[TC_NODES]{$_[1]} = $node = [];
        $node->[TC_KEY] = $_[1];

        # Create node in front
        my $head = $node->[TC_PREVIOUS] = $cacher->[TC_HEAD];
        my $next = $node->[TC_NEXT]	= $head->[TC_NEXT];
        $head->[TC_NEXT] = $next->[TC_PREVIOUS] = $node;

        push(@_, $node);
    }
    eval {
        &{$cacher->[TC_LOAD]};
        &{$cacher->[TC_SAVE]} if $cacher->[TC_SAVE];
    };
    return $node->[TC_DATA] unless $@;
    $cacher->delete($_[1]);
    die $@;
}

# end of Tie::Cacher::fetch
1;
